#include <Adafruit_NeoPixel.h>

#define PIN 3

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(160, PIN, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.
uint32_t Comet[3][5]={{0x00F0F0F0,0x00404040,0x00202020,0x00101010,0x00080808},{0x00F0F0F0,0x00501050,0x00301030,0x00100E10,0x000A0810},{0x00FF0000,0x00808000,0x00008000,0x00004080,0x0000FF}};
void setup() {
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {
  // Some example procedures showing how to display to the pixels:

  colorPoint(strip.Color(255, 50, 0), 64,1); // Fire
  colorPoint(strip.Color(255, 255, 255), 64,2); // Rainbow
  colorPoint(strip.Color(255, 255, 255), 64,0); // Komet
  BlinkPoint(strip.Color(255, 255, 255), 64,1); // Komet
  delay (1000);
}


// Walking Point
void colorPoint(uint32_t c, uint8_t wait,uint8_t band) 
{
  uint16_t i;
  
  for(i=0; i<strip.numPixels(); i++) 
  {
      strip.setPixelColor(i-13, 0);
      strip.setPixelColor(i-11, c & Comet[band][4]);
      strip.setPixelColor(i-9,c & Comet[band][3]);
      strip.setPixelColor(i-7,c & Comet[band][2]);
      strip.setPixelColor(i-5,c & Comet[band][1]);
      strip.setPixelColor(i-3,c & Comet[band][0]);
      if (band!=2) strip.setPixelColor(i, c & 0x00FFFFFF);
      strip.show();
      delay(wait);
  }
      strip.setPixelColor(strip.numPixels()-11, 0x00ff0000);
      strip.setPixelColor(strip.numPixels()-9,0);
      strip.setPixelColor(strip.numPixels()-7,0);
      strip.setPixelColor(strip.numPixels()-5,0);
      strip.setPixelColor(strip.numPixels()-3,0);
      strip.setPixelColor(strip.numPixels(), 0);
      strip.show();
 
  return;
}

//Glitter
void BlinkPoint(uint32_t c, uint8_t wait,uint8_t band) 
{
  uint16_t i;
  
  for(i=0; i<strip.numPixels(); i++) 
  {
      strip.setPixelColor(i-1, 0);
      //strip.setPixelColor(i-11, c & Comet[band][4]);
      //strip.setPixelColor(i-9,c & Comet[band][3]);
      //strip.setPixelColor(i-7,c & Comet[band][2]);
      //strip.setPixelColor(i-5,c & Comet[band][1]);
      //strip.setPixelColor(i-3,c & Comet[band][0]);
      //if (band!=2) strip.setPixelColor(i, c & 0x00FFFFFF);
      strip.show();
      delay(50);
      strip.setPixelColor(i-1, 0);
      //strip.setPixelColor(i-11, 0);
      //strip.setPixelColor(i-9,0);
      //strip.setPixelColor(i-7,0);
      //strip.setPixelColor(i-5,0);
      //strip.setPixelColor(i-3,0);
      if (band!=2) strip.setPixelColor(i, c & 0x00FFFFFF);
      strip.show();
      delay(wait);
  }
      //strip.setPixelColor(strip.numPixels()-11, 0x00ff0000);
      //strip.setPixelColor(strip.numPixels()-9,0);
      //strip.setPixelColor(strip.numPixels()-7,0);
      //strip.setPixelColor(strip.numPixels()-5,0);
      //strip.setPixelColor(strip.numPixels()-3,0);
      //strip.setPixelColor(strip.numPixels(), 0);
      strip.show();
 
  return;
}



// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();
     
      delay(wait);
     
      for (int i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
        for (int i=0; i < strip.numPixels(); i=i+3) {
          strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
        }
        strip.show();
       
        delay(wait);
       
        for (int i=0; i < strip.numPixels(); i=i+3) {
          strip.setPixelColor(i+q, 0);        //turn every third pixel off
        }
    }
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else if(WheelPos < 170) {
    WheelPos -= 85;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}
